Index: trunk/kernel/devices/dev_txt.h
===================================================================
--- trunk/kernel/devices/dev_txt.h	(revision 690)
+++ trunk/kernel/devices/dev_txt.h	(revision 1)
@@ -1,6 +1,6 @@
 /*
  * dev_txt.h - TXT (Text Terminal) generic device API definition.
- *
- * Author  Alain Greiner    (2016,2017,2018,2019))
+ * 
+ * Author  Alain Greiner    (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,40 +25,23 @@
 #define _DEV_TXT_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <xlist.h>
-#include <remote_busylock.h>
+#include <almos_config.h>
+#include <hal_types.h>
 
 /****  Forward declarations  ****/
 
-struct chdev_s ;
+struct device_s ;
 
 /******************************************************************************************
  *     Generic Text Terminal device definition.
  *
- * This multi-channels generic TXT device provides access to a text terminal.
- *
- * It supports two operations that must be implemented by the driver cmd() function:
+ * This multi-channels generic TXT device provide access to a text terminal.
+ * It supports three operation types :
  * - TXT_READ : read a single character from the text terminal identified by its channel
  *   index, using a descheduling strategy for the calling thread.
  * - TXT_WRITE : write a character string to the text terminal identified by its channel
  *   index, using a descheduling strategy for the calling thread.
- *
- * It supports one operation, that must be implemented by the driver aux() function  
- * - TXT_SYNC_WRITE write a character string to the TXT0 kernel terminal, using a busy 
- *   waiting strategy for the calling thread. 
+ * - TXT_SYNC_WRITE : write a character string to the terminal identified by its channel
+ *   index, using a busy waiting strategy for the calling thread. 
  *****************************************************************************************/
-
-/******************************************************************************************
- * This defines the (implementation independant) extension for the generic TXT device.
- *****************************************************************************************/
-
-typedef struct txt_extend_s
-{
-    xptr_t            owner_xp;  /*! ext. pointer on current process owner (reference)   */
-    xlist_entry_t     root;      /*! root of list of processes attached to same TXT      */
-    remote_busylock_t lock;      /*! lock protecting this list                           */
-}
-txt_extend_t;
 
 /******************************************************************************************
@@ -69,25 +52,24 @@
 enum txt_impl_e
 {
-    IMPL_TXT_TTY =   0,
-    IMPL_TXT_RS2 =   1,
-    IMPL_TXT_MTY =   2,
+    IMPL_TXT_TTY =   0,     
+    IMPL_TXT_X86 =   1,  
 }
 txt_impl_t;
 
 /******************************************************************************************
- * This defines the arguments passed to the driver CMD function.
+ * This defines the (implementation independant) command passed to the driver.
  *****************************************************************************************/
 
-typedef enum
+enum
 {
     TXT_READ       = 0,
     TXT_WRITE      = 1,
     TXT_SYNC_WRITE = 2,
-} dev_txt_cmd_t;
+};
 
 typedef struct txt_command_s
 {
     xptr_t      dev_xp;    /*! extended pointer on the relevant TXT device descriptor    */
-    uint32_t    type;      /*! TXT_READ / TXT_WRITE                                      */
+    uint32_t    type;      /*! TXT_READ / TXT_WRITE / TXT_SYNC_WRITE                     */
     xptr_t      buf_xp;    /*! extended pointer on characters array                      */
     uint32_t    count;     /*! number of characters in buffer (must be 1 if to_mem)      */
@@ -97,42 +79,23 @@
 
 /******************************************************************************************
- * This defines the arguments passed to the driver AUX function.
- * This function implement the TXT_SYNC_WRITE operation.
+ * This function completes the TXT device descriptor initialisation,
+ * namely the link with the implementation specific driver.
+ * The func, impl, channel, is_rxt, base, and size fields must be previously initialised.
+ * It calls the specific driver initialisation function, to initialise the hardware
+ * device and the driver specific data structures when required.
+ * It creates the associated server thread.
+ * It can be executed in another cluster than cluster containing the device descriptor
+ * or the hardware device itself.
+ ******************************************************************************************
+ * @ xp_dev     : extended pointer on TXT device descriptor.
  *****************************************************************************************/
-
-typedef struct txt_sync_args_s
-{
-    xptr_t       dev_xp;    /*! extended pointer on the TXT0_TX device descriptor        */
-    const char * buffer;    /*! local pointer on characters array                        */
-    uint32_t     count;     /*! number of characters in buffer                           */
-    uint32_t     channel;   /*! channel, aka which tty to write to                       */
-}
-txt_sync_args_t;
+void dev_txt_init( xptr_t xp_dev );
 
 /******************************************************************************************
- * This function returns a printable string for the command type.
- ******************************************************************************************
- * @ type     : command type (TXT_READ / TXT_WRITE / TXT_SYNC_WRITE)
- *****************************************************************************************/
-const char * dev_txt_type_str( dev_txt_cmd_t type );
-
-/******************************************************************************************
- * This function completes the TXT chdev descriptor initialisation,
- * namely the link with the implementation specific driver.
- * The func, impl, channel, is_rxt, base fields have been previously initialised.
- * It calls the specific driver initialisation function, to initialise the hardware
- * device and the driver specific data structures when required.
- * It creates the associated server thread and allocates a WTI from local ICU.
- * It must be executed by a thread running in cluster containing the chdev descriptor.
- ******************************************************************************************
- * @ chdev     : local pointer on TXT device descriptor.
- *****************************************************************************************/
-void dev_txt_init( struct chdev_s * chdev );
-
-/******************************************************************************************
- * This blocking function reads a single character from the terminal identified
+ * This blocking function read a single character from the terminal identified
  * by the "channel" argument. The corresponding request is actually registered in the
- * chdev requests queue, and the calling thread is descheduled, blocked until
- * transfer completion. It can be called by any thread running in any cluster.
+ * device pending requests queue, and the calling thread is descheduled, blocked until
+ * transfer completion.
+ * It must be called in the client cluster.
  ******************************************************************************************
  * @ channel   : TXT channel index.
@@ -144,8 +107,9 @@
 
 /******************************************************************************************
- * This blocking function writes characters on the terminal identified
+ * This blocking function writes a character string on the terminal identified
  * by the "channel" argument. The corresponding request is actually registered in the
- * chdev requests queue, and the calling thread is descheduled, blocked until
- * transfer completion. It can be called by any thread running in any cluster.
+ * device pending requests queue, and the calling thread is descheduled, blocked until
+ * transfer completion.
+ * It must be called in the client cluster.
  ******************************************************************************************
  * @ channel   : TXT channel index.
@@ -158,18 +122,35 @@
                        uint32_t        count );
 
-/***************************************************************************************
- * This blocking function is used by the kernel to display a string on the TXT0
- * terminal, without descheduling the calling thread, without registering it
- * in the TXT0 device waiting queue, without using the TXT0 irq, and without
- * interfering with another possible TXT access to another terminal.
- * As it is used for debug, the command arguments <buffer> and <count> are registerd
- * in a specific "txt_sync_args_t" structure passed to the driver "aux" function.
+ /***************************************************************************************
+ * This low-level blocking function is used by the kernel to display one character on a 
+ * given TXT channel without descheduling the calling thread,  without registering it 
+ * in the TXT device waiting queue, and without using the TXT irq. 
  ****************************************************************************************
+ * @ channel   : TXT channel index.
  * @ buffer    : local pointer on source buffer containing the string.
  * @ count     : number of characters.
  * @ returns 0 if success / returns EINVAL if error.
  ***************************************************************************************/
-error_t dev_txt_sync_write( const char     * buffer,
-                            uint32_t         count );
+error_t dev_txt_sync_write( uint32_t   channel,
+                            char     * buffer,
+                            uint32_t   count );
+
+/******************************************************************************************
+ * This function is executed by the server thread associated to the TXT device descriptor.
+ * This thread is created and lauched by the dev_txt_init() function, and is used
+ * by the TXT_READ and TXT_WRITE operation types. It executes an infinite loop to handle
+ * sequencially all commands registered by the client threads in the device waiting queue.
+ *  
+ * The driver CMD function is blocking, and returns only when the command is completed.
+ * can use a busy waiting policy, or block the server thread on the THREAD_BLOCKED_IO_ISR
+ * condition and deschedule, using the ISR to reactivate the server thread.
+ *
+ * When the waiting queue is empty, the server thread blocks on the THREAD_BLOCKED_IO_CMD
+ * condition and deschedule. It is re-activated by a client thread registering a command.
+ ******************************************************************************************
+ * @ dev     : local pointer on device descriptor.
+ *****************************************************************************************/
+void dev_txt_server( struct device_s * dev );
+
 
 #endif	/* _DEV_TXT_H_ */
Index: trunk/kernel/drivers/ibmpc/ata.c
===================================================================
--- trunk/kernel/drivers/ibmpc/ata.c	(revision 1)
+++ trunk/kernel/drivers/ibmpc/ata.c	(revision 1)
@@ -0,0 +1,228 @@
+/*
+ * ata.c - ATA hard disk driver
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <device.h>
+#include <driver.h>
+#include <cpu.h>
+#include <thread.h>
+#include <scheduler.h>
+#include <kmem.h>
+#include <sysio.h>
+#include <string.h>
+#include <event.h>
+#include <cpu-trace.h>
+#include <cpu-io.h>
+#include <ata.h>
+
+#define ATA_BASE(x)  ((x) & 0xFFFF)
+#define ATA_DRIVE(x) ((x) >> 16)
+
+static void ata_start_request(struct device_s *dev, dev_request_t *rq, uint32_t type)
+{
+	uint16_t base  = ATA_BASE((uint32_t)dev->base);
+	uint16_t drive = ATA_DRIVE((uint32_t)dev->base);
+	uint32_t lba   = (uint32_t)rq->src;
+
+	cpu_io_out8(base + ATA_ERROR_REG, 0x00);
+	cpu_io_out8(base + ATA_COUNT_REG, rq->count);
+	cpu_io_out8(base + ATA_LBA_LOW_REG, (uint8_t)lba); 
+	cpu_io_out8(base + ATA_LBA_MID_REG, (uint8_t)(lba >> 8));
+	cpu_io_out8(base + ATA_LBA_HIGH_REG,(uint8_t)(lba >> 16));
+	cpu_io_out8(base + ATA_DRIVE_REG, 0xE0 | (drive << 4) | ((lba >> 24) & 0x0F));
+	cpu_io_out8(base + ATA_CMD_REG, type);
+}
+
+error_t ata_busy_wait(uint_t base)
+{
+	uint_t val;
+	uint_t val2;
+
+	while((val=cpu_io_in8(base + ATA_STATUS_REG)) & ATA_BSY)
+		val ++;
+  
+	val2 = val;
+
+	return val2 - val;
+}
+
+static void ata_finalize_request(struct device_s *dev, dev_request_t *rq, uint32_t type)
+{
+	register uint16_t val;
+	register uint16_t base;
+	register uint_t index;
+	register uint8_t *buffer;  
+	error_t err;
+
+	base = ATA_BASE((uint32_t)dev->base);
+	buffer = (uint8_t*) rq->dst;
+
+	if((err=ata_busy_wait(base)))
+	{
+		printk(ERROR, "ERROR: ata_finalize_request: time out [dev %x, cmd %x, start lba %d, count %d]\n", 
+		       dev->base, 
+		       type, 
+		       (uint32_t)rq->src, 
+		       rq->count);
+
+		return;
+	}
+
+	if(type == ATA_READ_CMD)
+	{
+		for (index = 0; index < 256 * rq->count; index++) 
+		{
+			val = cpu_io_in16(base + ATA_DATA_REG);
+			buffer[index * 2    ] = (uint8_t) val;
+			buffer[index * 2 + 1] = (uint8_t)(val >> 8);
+		}
+		return;
+	}
+  
+	for (index = 0; index < 256 * rq->count; index++) 
+	{
+		val = (buffer[index * 2 + 1] << 8) | buffer[index * 2];
+		cpu_io_out16(base + ATA_DATA_REG, val);
+	}
+}
+
+void __attribute__ ((noinline)) ata_irq_handler(struct irq_action_s *action)
+{
+	register struct device_s *hdd;
+	register struct ata_context_s *ctx;
+	uint16_t base;
+	uint8_t status;
+
+	cpu_trace_write(CURRENT_THREAD->local_cpu, ata_irq_handler);
+
+	hdd = action->dev;
+	base = ATA_BASE((uint32_t)hdd->base);
+	ctx = (struct ata_context_s*)hdd->data;
+
+	status = cpu_io_in8(base + ATA_STATUS_REG); /* IRQ ACK */
+
+	isr_dmsg(INFO, "INFO: Recived irq on DevBlk %x, Drive %d, status %x\n", 
+		 base, 
+		 ATA_DRIVE((uint32_t)hdd->base), 
+		 status);
+}
+
+
+int32_t __attribute__ ((noinline)) ata_request(struct device_s *blk_dev, dev_request_t *rq, uint32_t type)
+{
+	struct ata_context_s *ctx;
+
+	cpu_trace_write(CURRENT_THREAD->local_cpu, ata_request);
+  
+	ctx = (struct ata_context_s*)blk_dev->data;
+
+	if((rq->count + ((uint_t)rq->src)) > ctx->params.blk_count)
+		return -1;
+
+	ata_start_request(blk_dev, rq, type);
+	ata_finalize_request(blk_dev, rq, type);
+
+	return 0;
+}
+
+
+static sint_t ata_read(struct device_s *blk_dev, dev_request_t *rq)
+{
+	return ata_request(blk_dev, rq, ATA_READ_CMD);
+}
+
+
+static sint_t ata_write(struct device_s *blk_dev, dev_request_t *rq)
+{
+	return ata_request(blk_dev, rq, ATA_WRITE_CMD);
+}
+
+
+static sint_t ata_get_params(struct device_s *blk_dev, dev_params_t *params) 
+{
+	struct ata_context_s *ctx = (struct ata_context_s*) blk_dev->data;
+	params->blk.count = ctx->params.blk_count;
+	params->blk.size = ctx->params.blk_size;
+	return 0;
+}
+
+void ibmpc_ata_init(struct device_s *hdd, void *base, uint_t irq)
+{
+	struct ata_context_s *ctx;
+	error_t err;
+	uint_t index;
+	uint16_t *buffer;
+	uint16_t dev_base;
+	uint16_t drive;
+
+	spinlock_init(&hdd->lock);
+	hdd->base = base;
+	hdd->irq = irq;
+	hdd->type = DEV_BLK;
+
+	hdd->action.dev = hdd;
+	hdd->action.irq_handler = &ata_irq_handler;
+	hdd->action.data = NULL;
+
+	strcpy(hdd->name, "BLK-DEV");
+	metafs_init(&hdd->node, hdd->name);
+
+	hdd->op.dev.open = NULL;
+	hdd->op.dev.read = &ata_read;
+	hdd->op.dev.write = &ata_write;
+	hdd->op.dev.close = NULL;
+	hdd->op.dev.lseek = NULL;
+	hdd->op.dev.get_params = &ata_get_params;
+	hdd->op.dev.set_params = NULL;
+
+	ctx = kbootMem_calloc(sizeof(*ctx));
+	list_root_init(&ctx->request_queue);
+	wait_queue_init(&ctx->pending, hdd->name);
+  
+	dev_base = ATA_BASE((uint32_t)base);
+	drive = ATA_DRIVE((uint32_t)base);
+
+	cpu_io_out8(dev_base + ATA_DRIVE_REG, 0xA0 | (drive << 4));
+	cpu_io_out8(dev_base + ATA_CMD_REG, ATA_IDENTIFY_CMD);
+  
+	if((err=ata_busy_wait(dev_base)))
+	{
+		printk(ERROR, "ERROR: ibmpc_ata_init: dev %x, ATA_IDENTIFY_CMD time out\n", dev_base);
+		return;
+	}
+
+	buffer = (uint16_t *)&ctx->params.info;
+
+	for(index = 0; index < 256; index++)
+		buffer[index] = cpu_io_in16(dev_base + ATA_DATA_REG);
+  
+	assert((ctx->params.info.capabilities & ATA_LBA_CAP) && "LBA mode is mandatory");
+  
+	ctx->params.blk_size = 512;
+	ctx->params.blk_count = ctx->params.info.sectors;
+	hdd->data = (void *)ctx;
+	
+	printk(INFO, "INFO: ATA(%x) Drive(%d): (size,count) %d:%d\n", 
+	       dev_base, 
+	       drive, 
+	       ctx->params.blk_size, 
+	       ctx->params.blk_count);
+}
Index: trunk/kernel/drivers/ibmpc/ata.h
===================================================================
--- trunk/kernel/drivers/ibmpc/ata.h	(revision 1)
+++ trunk/kernel/drivers/ibmpc/ata.h	(revision 1)
@@ -0,0 +1,109 @@
+/*
+ * ata.h - ATA interface registers
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _ATA_H_
+#define _ATA_H_
+
+#include <types.h>
+#include <list.h>
+#include <driver.h>
+
+/* ATA Task File offsets */
+#define ATA_DATA_REG	        0
+#define ATA_ERROR_REG	        1
+#define ATA_PRECOMPENSATION_REG	1
+#define ATA_COUNT_REG           2
+#define ATA_LBA_LOW_REG	        3
+#define ATA_LBA_MID_REG	        4
+#define ATA_LBA_HIGH_REG	5
+#define ATA_DRIVE_REG	        6
+#define ATA_STATUS_REG          7
+#define ATA_CMD_REG             7
+
+#define ATA_DOR_PORT         0x3F6
+
+/* ATA Status Register bits */
+#define ATA_ERR              0x01
+#define ATA_IDX              0x02
+#define ATA_CORR             0x04
+#define ATA_DRQ              0x08
+#define ATA_DSC              0x10
+#define ATA_WFT              0x20
+#define ATA_DRDY	     0x40
+#define ATA_BSY	             0x80
+
+
+/* ATA Error Register bits */
+
+/* Block device status */
+#define ATA_IDLE	        0
+#define ATA_BUSY	        1
+#define ATA_READ_SUCCESS	2
+#define ATA_WRITE_SUCCESS	3
+#define ATA_READ_ERROR	        4
+#define ATA_WRITE_ERROR	        5
+#define ATA_ERROR	        6
+
+#define ATA_READ_CMD            0x020
+#define ATA_WRITE_CMD           0x030
+#define ATA_IDENTIFY_CMD        0x0EC
+
+#define ATA_LBA_CAP             0x0100
+
+struct device_s;
+
+struct ata_identify_s
+{
+	uint16_t general;
+	uint16_t geometry[6];
+	uint16_t vendor_id1[3];
+	uint16_t info1[37];
+	uint16_t vendor_id2;
+	uint16_t info2;
+	uint16_t capabilities;
+	uint16_t info3[10];
+	uint32_t sectors;
+	//uint16_t lblock_lo;
+	//uint16_t lblock_hi;
+	uint32_t info4;
+	uint16_t reserved1[64];
+	uint16_t vendor_id3[32];
+	uint16_t reserved2[96];
+} __attribute__ ((packed));
+
+struct ata_params_s
+{
+	uint32_t blk_count;
+	uint32_t blk_size;
+	struct ata_identify_s info;
+};
+
+struct ata_context_s
+{
+	struct list_entry request_queue;
+	struct wait_queue_s pending;
+	struct ata_params_s params;
+};
+
+void ibmpc_ata_init(struct device_s *hdd, void *base, uint_t irq);
+
+#endif /* _ATA_H_ */
Index: trunk/kernel/drivers/ibmpc/pci-bus.h
===================================================================
--- trunk/kernel/drivers/ibmpc/pci-bus.h	(revision 1)
+++ trunk/kernel/drivers/ibmpc/pci-bus.h	(revision 1)
@@ -0,0 +1,79 @@
+/*
+ * pci.c - PCI bus related registers and access functions
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _PCI_BUS_H_
+#define _PCI_BUS_H_
+
+#include <types.h>
+#include <cpu-io.h>
+
+#define PCI_TGT_MAX_CONFIG_SPACE      256
+#define PCI_TGT_MAX_CONFIG_REG        64
+#define PCI_BUS_MAX_NR                255
+#define PCI_BUS_DEV_MAX_NR            32
+#define PCI_DEV_FUNC_MAX_NR           8
+
+#define PCI_CONFIG_ADDR               0xCF8
+#define PCI_CONFIG_DATA               0xCFC
+
+#define PCI_STD_DEV_TYPE              0x00
+#define PCI_BRIDGE_TYPE               0x01
+#define PCI_CARDBUS_BRIDGE_TYPE       0x02
+
+#define PCI_VENDOR_ID                 0x00
+#define PCI_DEVCIE_ID                 0x02
+#define PCI_CMD_REG                   0x04
+#define PCI_STATUS_REG                0x06
+#define PCI_REVISION_ID               0x08
+
+#define PCI_CLASS_ID                  0x0A
+#define PCI_HEADER_TYPE               0x0E
+
+#define PCI_BAR0                      0x10
+#define PCI_BAR1                      0x14
+#define PCI_BAR2                      0x18
+#define PCI_BAR3                      0x1C
+#define PCI_BAR4                      0x20
+#define PCI_BAR5                      0x24
+
+#define PCI_INT_INFO 0x3C
+
+#define pci_mkconfig1_addr(_bus,_dev,_func,_offset)	\
+	((uint32_t)(0x80000000    | ((_bus) << 16) |	\
+		    ((_dev) << 11) | ((_func) << 8) |	\
+		    ((_offset) & 0xfc)))
+
+
+static inline uint16_t pci_config_read(uint_t bus, uint_t slot, uint_t func, uint_t offset)
+{ 
+	uint32_t addr;
+	uint32_t val; 
+
+	addr = pci_mkconfig1_addr(bus,slot,func,offset);
+
+	cpu_io_out32(PCI_CONFIG_ADDR, addr);
+	val = cpu_io_in32(PCI_CONFIG_DATA);
+
+	return val >> ((offset & 3) * 8);
+}
+
+#endif	/* _PCI_BUS_H_ */
Index: trunk/kernel/drivers/ibmpc/pic.c
===================================================================
--- trunk/kernel/drivers/ibmpc/pic.c	(revision 1)
+++ trunk/kernel/drivers/ibmpc/pic.c	(revision 1)
@@ -0,0 +1,153 @@
+/*
+ * pic.h - Programmable Interrupt Controller driver implementation
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
+#include <cpu-io.h>
+#include <kmem.h>
+#include <string.h>
+#include <kdmsg.h>
+#include <pic.h>
+
+#define PIC_PRIMARY_PIO    0x20
+#define PIC_SECONDARY_PIO  0xA0
+
+struct irq_action_s *irq_vector[PIC_IRQ_MAX];
+
+static void pic_set_mask(struct device_s *pic, uint_t mask, uint_t type, uint_t output_irq)
+{
+	switch(type)
+	{
+	case 0:
+		cpu_io_out8(PIC_PRIMARY_PIO + PIC_IMR_REG, ~(mask & 0xFF));
+		break;
+	case 1:
+		cpu_io_out8(PIC_SECONDARY_PIO + PIC_IMR_REG, ~(mask & 0xFF));
+		break;
+	default:
+		printk(ERROR, "ERROR: Un expected mask value, PIC has 16 IRQ line only [ type 0 & 1 ]");
+	}
+}
+
+static uint_t pic_get_mask(struct device_s *icu, uint_t type, uint_t output_irq)
+{
+	register uint_t mask = ~0;
+  
+	switch(type)
+	{
+	case 0:
+		mask = cpu_io_in8(PIC_PRIMARY_PIO + PIC_IMR_REG);
+		break;
+	case 1:
+		mask = cpu_io_in8(PIC_SECONDARY_PIO + PIC_IMR_REG);
+		break;
+	default:
+		printk(ERROR, "ERROR: Un expected mask value, PIC has 16 IRQ line only [ type 0 & 1 ]");
+	}
+  
+	return ((~mask) & 0xFF);
+}
+
+static sint_t pic_get_highest_irq(struct device_s *icu, uint_t type, uint_t output_irq)
+{
+	return -1;
+}
+
+static void pic_default_irq_handler(struct irq_action_s *action)
+{
+	register unsigned int irq_num = (unsigned int) action->data;
+	register unsigned int cpu_id  = cpu_get_id();
+  
+	isr_dmsg(WARNING, "WARNING: No ISR registered handler for IRQ %d on CPU %d\n",irq_num, cpu_id);
+}
+
+static void pic_ICWs()
+{
+	/* ICW1 */
+	cpu_io_out8(PIC_PRIMARY_PIO + PIC_CMD_REG, 0x11); /* Put Primary PIC in Initialization mode with ICW4 enabled */
+	cpu_io_out8(PIC_SECONDARY_PIO + PIC_CMD_REG, 0x11); /* Same ICW1 as Primary */
+
+	/* ICW2 */
+	cpu_io_out8(PIC_PRIMARY_PIO + PIC_DATA_REG, 0x20); /* Set Primary PIC's interrupt vector base number */
+	cpu_io_out8(PIC_SECONDARY_PIO + PIC_DATA_REG, 0x28); /* Set Secondary PIC's interrupt vector base number */
+
+	/* ICW3 */
+	cpu_io_out8(PIC_PRIMARY_PIO + PIC_DATA_REG, 0x4); /* Informe Primary that Secondary is connected to line 2 */
+	cpu_io_out8(PIC_SECONDARY_PIO + PIC_DATA_REG, 0x2); /* Inform Secondary of it's identification */
+
+	/* ICW4 */
+	cpu_io_out8(PIC_PRIMARY_PIO + PIC_DATA_REG, 0x1); /* Put Primary in x86 mode */
+	cpu_io_out8(PIC_SECONDARY_PIO + PIC_DATA_REG, 0x1); /* Put Primary in x86 mode */
+
+	/* CLEAR DATA REGISTERS */
+	cpu_io_out8(PIC_PRIMARY_PIO + PIC_DATA_REG, 0);
+	cpu_io_out8(PIC_SECONDARY_PIO + PIC_DATA_REG, 0);
+}
+
+
+void pic_irq_handler(struct irq_action_s *action)
+{
+	register uint_t irq = (uint_t)action->data;
+	irq_vector[irq]->data = (void*)irq;
+	irq_vector[irq]->irq_handler(irq_vector[irq]);
+}
+
+void ibmpc_pic_init(struct device_s *pic, void *base, uint_t irq)
+{
+	register uint_t _irq;
+	struct irq_action_s *action_ptr;
+
+	pic->base = base;
+	pic->type = DEV_ICU;
+	pic->action.irq_handler = &pic_irq_handler;
+
+	strcpy(pic->name, "PIC");
+	metafs_init(&pic->node, pic->name);
+  
+	pic->op.icu.set_mask = &pic_set_mask;
+	pic->op.icu.get_mask = &pic_get_mask;
+	pic->op.icu.get_highest_irq = &pic_get_highest_irq;
+
+	for(_irq=0; _irq < PIC_IRQ_MAX; _irq++)
+	{
+		action_ptr = kbootMem_calloc(sizeof(*action_ptr));
+		action_ptr->dev = pic;
+		action_ptr->irq_handler = &pic_default_irq_handler;
+		action_ptr->data = (void*) _irq;   
+		irq_vector[_irq] = action_ptr;
+	}
+  
+	pic_ICWs();
+}
+
+void ibmpc_pic_bind(struct device_s *pic, struct device_s *dev)
+{
+	assert(dev->irq < PIC_IRQ_MAX && "Unexpected IRQ, connot bind this device");
+
+	if(dev->irq < PIC_IRQ_MAX)
+	{
+		irq_vector[dev->irq] = &dev->action;
+		metafs_register(&pic->node, &dev->node);
+	}
+}
Index: trunk/kernel/drivers/ibmpc/pic.h
===================================================================
--- trunk/kernel/drivers/ibmpc/pic.h	(revision 1)
+++ trunk/kernel/drivers/ibmpc/pic.h	(revision 1)
@@ -0,0 +1,41 @@
+/*
+ * pic.h - Programmable Interrupt Controller driver interface
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _PIC_ICU_H_
+#define _PIC_ICU_H_
+
+#define PIC_IRQ_MAX          64    // IRQ input lines (see __kentry.S)
+
+/* PIC mapped registers offset */
+#define PIC_CMD_REG          0	        /* Command Register */
+#define PIC_STATUS_REG       0		/* Status Register  */
+#define PIC_IMR_REG	     1          /* Interrupt Mask Register */
+#define PIC_DATA_REG         1		/* Data Register */
+
+struct irq_action_s;
+struct device_s;
+extern struct irq_action_s *irq_vector[];
+
+void ibmpc_pic_init(struct device_s *pic, void *base, uint_t irq);
+void ibmpc_pic_bind(struct device_s *pic, struct device_s *dev);
+
+#endif	/* _PIC_ICU_H_ */
